package kr.co.vividnext.sodalive.aws.sqs

import org.springframework.context.event.EventListener
import org.springframework.scheduling.annotation.Async
import org.springframework.stereotype.Component

enum class SqsEventType {
    GENERATE_COUPON
}

class SqsEvent(
    val type: SqsEventType,
    val message: String
)

@Component
class SqsEventListener(private val sqsService: SqsService) {
    @Async
    @EventListener
    fun sendMessage(sqsEvent: SqsEvent) {
        when (sqsEvent.type) {
            SqsEventType.GENERATE_COUPON -> sqsService.sendGenerateCouponMessage(sqsEvent.message)
        }
    }
}
