package kr.co.vividnext.sodalive.content.main.curation.tag

import kr.co.vividnext.sodalive.common.BaseEntity
import kr.co.vividnext.sodalive.content.AudioContent
import javax.persistence.Entity
import javax.persistence.FetchType
import javax.persistence.JoinColumn
import javax.persistence.ManyToOne

@Entity
data class ContentHashTagCuration(
    var tag: String,
    var orders: Int = 1,
    var isAdult: Boolean = false,
    var isActive: Boolean = true
) : BaseEntity()

@Entity
data class ContentHashTagCurationItem(
    var orders: Int = 1,
    var isActive: Boolean = true
) : BaseEntity() {
    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "curation_id", nullable = false)
    var curation: ContentHashTagCuration? = null

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "content_id", nullable = false)
    var content: AudioContent? = null
}
