package kr.co.vividnext.sodalive.fcm

import com.querydsl.jpa.impl.JPAQueryFactory
import kr.co.vividnext.sodalive.fcm.QPushToken.pushToken
import org.springframework.data.jpa.repository.JpaRepository

interface PushTokenRepository : JpaRepository<PushToken, Long>, PushTokenQueryRepository

interface PushTokenQueryRepository {
    fun findByToken(token: String): PushToken?
    fun findByMemberId(memberId: Long): List<PushToken>
}

class PushTokenQueryRepositoryImpl(
    private val queryFactory: JPAQueryFactory
) : PushTokenQueryRepository {
    override fun findByToken(token: String): PushToken? {
        return queryFactory
            .selectFrom(pushToken)
            .where(pushToken.token.eq(token))
            .fetchFirst()
    }

    override fun findByMemberId(memberId: Long): List<PushToken> {
        return queryFactory
            .selectFrom(pushToken)
            .where(pushToken.member.id.eq(memberId))
            .fetch()
    }
}
